﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using WAD.Infrastructure;
using WAD.Infrastructure.Request;
using WAD.Infrastructure.Response;

namespace WAD.Entity.DTO.Product
{
    public class GetProductRequest : IRequest
    {
        /// <summary>
        /// 商品编号
        /// </summary>
        public int? ProductID { get; set; }
        public ResultObject Validate()
        {
            if (ProductID == null || ProductID.Value <= 0)
            {
                return new ResultObject { Code = 1, Msg = "商品编号有误" };
            }
            return null;
        }
    }

    public class GetProductResponse : IResponse
    {
        /// <summary>
        /// 编号
        /// </summary>
        public int? ID { get; set; }
        /// <summary>
        /// 商品名称
        /// </summary>
        public string Name { get; set; }

        /// <summary>
        /// 颜色集合
        /// </summary>
        public List<string> Colors { get; set; }
        public List<ProductTag> TagList { get; set; }
    }

    public class ProductTag
    {
        /// <summary>
        /// 标签编号
        /// </summary>
        public int ID { get; set; }
        /// <summary>
        /// 标签名称
        /// </summary>
        public string TagName { get; set; }
    }
}
