﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Web;
using System.Web.Mvc;
using System.Xml;
using WAD.WebBase;

namespace WebApiDemo.Controllers
{
    public class ApiController : Controller
    {
        // GET: Api
        public ActionResult Index()
        {
            var apiType = typeof(ApiControllerBase);
            var assem = Assembly.GetExecutingAssembly();
            var conotrollerTypes = assem.GetTypes().Where(type => type.IsSubclassOf(apiType)).ToList();

            ViewBag.conotrollerTypes = conotrollerTypes;
            ViewBag.SummaryDict = getSummaryDict();

            return View();
        }

        Dictionary<string, string> getSummaryDict()
        {
            var path = Server.MapPath("~/") + "bin\\";
            var files = Directory.GetFiles(path, "*.xml");
            Dictionary<string, string> msDict = new Dictionary<string, string>();

            foreach (var file in files)
            {
                XmlDocument xmldoc = new XmlDocument();
                xmldoc.Load(file);
                var memberNodes = xmldoc.SelectNodes("/doc/members/member");
                foreach (XmlNode item in memberNodes)
                {
                    var name = item.Attributes["name"].Value;
                    if (name.StartsWith("P:")) //只取属性
                    {
                        var summaryNode = item.SelectSingleNode("summary");
                        if (summaryNode != null)
                        {
                            msDict[name] = summaryNode.InnerText.Trim();
                        }
                    }
                }
            }
            return msDict;
        }
    }
}