﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using WAD.Infrastructure.DataBase;
using Loogn.OrmLite;
using System.Text;

namespace WebApiDemo.Controllers
{
    public class GMController : Controller
    {
        public ActionResult Index()
        {
            using (var db = DB.Open())
            {
                return View(db.SelectTableMetaData());
            }
        }

        public ActionResult Generate(string[] tableNames)
        {
            if (tableNames == null || tableNames.Length == 0)
            {
                return Content("没有选择数据库");
            }
            var path = Server.MapPath("~/") + "../WAD.Entity/Model";
            EnsurePath(path);
            using (var db = DB.Open())
            {
                var tables = db.SelectTableMetaData(true).Where(t => tableNames.Contains(t.Name));
                StringBuilder sb = new StringBuilder();
                foreach (var table in tables)
                {
                    ViewBag.tableInfo = table;
                    var modelCode = RenderPartialViewToString(this, "Model");
                    System.IO.File.WriteAllText(Path.Combine(path, table.Name + ".cs"), modelCode, Encoding.UTF8);
                }
                return Content("生成成功");
            }
        }

        static string RenderPartialViewToString(Controller controller, string partialViewName)
        {
            IView view = ViewEngines.Engines.FindPartialView(controller.ControllerContext, partialViewName).View;
            using (StringWriter writer = new StringWriter())
            {
                ViewContext viewContext = new ViewContext(controller.ControllerContext, view, controller.ViewData, controller.TempData, writer);
                viewContext.View.Render(viewContext, writer);
                return writer.ToString();
            }
        }

        void EnsurePath(string path)
        {
            if (!Directory.Exists(path))
            {
                Directory.CreateDirectory(path);
            }
        }
    }
}